# Panel Material UI

Welcome to Panel Material UI – a library that brings the sleek look and comprehensive component set of Material UI into the world of Panel.

## Why Panel Material UI?

- **Consistent Look & Feel**
  Panel Material UI leverages Material UI’s design principles to give your Panel dashboards and applications a modern, cohesive style.

- **Easy Theming & Styling**
  Take control of your UI using Material UI’s theming concepts. Customize colors, typography, spacing, and more with minimal configuration. Quickly modify styling for one-off situations using the sx parameter or create global overrides via theme_config.

- **Seamless Dark Mode**
  Effortlessly toggle between light and dark palettes. Whether you want a permanently dark dashboard, a user-driven switch, or to match the system preference, Panel Material UI has you covered.

- **Familiar Panel API**
All components provide a similar API to native Panel widgets, ensuring a smooth developer experience. Pass parameters, bind widgets to reactive functions, and lay them out using Panel’s layout system.

- **Rich Component Set**
Access a growing collection of Material UI–inspired components (Buttons, Sliders, Cards, Dialogs, and more), all adapted to work with Panel. Spend less time building UI from scratch and more time showcasing your data.

- **Powerful Theming Inheritance**
  Define a theme at a parent level and let it automatically apply to child components without extra configuration, reducing repetitive code while maintaining consistent branding.

## Getting Started

Install Panel Material UI

:::::{tab-set}

::::{tab-item} pip
:sync: pip

```bash
pip install panel_material_ui
```

::::

::::{tab-item} conda
:sync: conda

```bash
conda install -c conda-forge panel_material_ui
```
::::

:::::

```{toctree}
:titlesonly:
:hidden:
:maxdepth: 2
:caption: FOR USERS

customization/index
reference/index
```
